/*----------------------------------------------------------------------------*/
/*
  This file is generated by Code_Saturne, a general-purpose CFD tool.
*/
/*----------------------------------------------------------------------------*/

#include "cs_defs.h"

/*----------------------------------------------------------------------------
 * Standard C library headers
 *----------------------------------------------------------------------------*/

#include <assert.h>
#include <math.h>

#if defined(HAVE_MPI)
#include <mpi.h>
#endif

/*----------------------------------------------------------------------------
 *  Local headers
 *----------------------------------------------------------------------------*/

#include "cs_headers.h"
/*----------------------------------------------------------------------------*/

BEGIN_C_DECLS

/*----------------------------------------------------------------------------*/

cs_real_t *
cs_meg_boundary_function(const cs_zone_t *zone,
                         const char      *field_name,
                         const char      *condition)
{
  cs_real_t *new_vals = NULL;

  /*--------------------------------------------------*/
  /* User defined formula for "velocity" over BC=BC_1 */
  if (strcmp(field_name, "velocity") == 0 &&
      strcmp(condition, "norm_formula") == 0 &&
      strcmp(zone->name, "BC_1") == 0) {

    const cs_real_3_t *xyz = (cs_real_3_t *)cs_glob_mesh_quantities->b_face_cog;

    const int vals_size = zone->n_elts * 1;
    BFT_MALLOC(new_vals, vals_size, cs_real_t);


    for (cs_lnum_t e_id = 0; e_id < zone->n_elts; e_id++) {
      cs_lnum_t f_id = zone->elt_ids[e_id];
      const cs_real_t z = xyz[f_id][2];

      new_vals[0 * zone->n_elts + e_id] =  (0.43 / 0.4) * log(z) ;
    }
  }
  /*--------------------------------------------------*/

  return new_vals;
}

/*----------------------------------------------------------------------------*/

END_C_DECLS

